#property indicator_chart_window

extern int    FanMode          = 3;
extern string Note1_________   = "0=HighToLow/LowToHigh; 1=OpenToLow/OpenToHigh;";
extern string Note2_________   = "2=OpenToPeriodLow/OpenToPeriodHigh; 3=FixedDates&Prices";
extern string TimeFrame        = "D1";
extern int    BarForHighLow    = 0;
extern int    ExtendBars       = 1;

extern string Note3_________   = "=========Settings for FixedDates&Price (FanMode = 3) =========";
extern double EndPrice         = 500;
extern int    EndTime          = 100;
extern string EndTimeTF        = "M30";
extern string ______________   = "==============================================================";

extern string UniqueID         = "GannFan";
extern color  ColorForDown     = Red;
extern color  ColorForUp       = DeepSkyBlue;
extern color  ColorForCenterDn = White;
extern color  ColorForCenterUp = White;
extern int    TrendLineStyle   = STYLE_SOLID;
extern int    TrendLineWidth   = 1;
extern bool   ShowDegree0      = True;
extern bool   ShowDegree1      = True;
extern bool   ShowDegree2      = True;
extern bool   ShowDegree3      = True;
extern bool   ShowDegree4      = True;
extern bool   ShowHighFan      = True;
extern bool   ShowLowFan       = True;


int timeFrame;
int endTimetimeFrame;

//------------------------------------------------------------------+
//                                                                  |
//------------------------------------------------------------------+

int init()
{
   timeFrame        = stringToTimeFrame(TimeFrame);
   endTimetimeFrame = stringToTimeFrame(EndTimeTF);
   return(0);
}

int deinit()
{
   int lookForLen = StringLen(UniqueID);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if (StringSubstr(name,0,lookForLen)==UniqueID) ObjectDelete(name);
   }      
   return(0);
}

//------------------------------------------------------------------+
//                                                                  |
//------------------------------------------------------------------+

int start() 
{
   if(FanMode == 0)
   {
      if(ShowHighFan) drawFan(UniqueID+timeFrameToString(timeFrame)+":1:",
                           iHigh(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow),
                           iLow (NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow)+ExtendBars*60*timeFrame,
                           ColorForDown,ColorForCenterDn,TrendLineWidth);
      if(ShowLowFan)  drawFan(UniqueID+timeFrameToString(timeFrame)+":2:",
                           iLow (NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow),
                           iHigh(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow)+ExtendBars*60*timeFrame,
                           ColorForUp,ColorForCenterUp,TrendLineWidth);
   }
   if(FanMode == 1)
   {
      if(ShowHighFan) drawFan(UniqueID+timeFrameToString(timeFrame)+":1:",
                           iOpen(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow),
                           iLow (NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow)+ExtendBars*60*timeFrame,
                           ColorForDown,ColorForCenterDn,TrendLineWidth);
      if(ShowLowFan)  drawFan(UniqueID+timeFrameToString(timeFrame)+":2:",
                           iOpen(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow),
                           iHigh(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow)+ExtendBars*60*timeFrame,
                           ColorForUp,ColorForCenterUp,TrendLineWidth);
   }
   if(FanMode == 2)
   {
      if(ShowHighFan) drawFan(UniqueID+timeFrameToString(timeFrame)+":1:",
                           iOpen(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow),
                           iLow (NULL,timeFrame,BarForHighLow),iTime(NULL,0,iLowest (NULL,0,MODE_LOW, iBarShift(NULL,0,iTime(NULL,timeFrame,BarForHighLow),0))),
                           ColorForDown,ColorForCenterDn,TrendLineWidth);
      if(ShowLowFan)  drawFan(UniqueID+timeFrameToString(timeFrame)+":2:",
                           iOpen(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow),
                           iHigh(NULL,timeFrame,BarForHighLow),iTime(NULL,0,iHighest(NULL,0,MODE_HIGH,iBarShift(NULL,0,iTime(NULL,timeFrame,BarForHighLow),0))),
                           ColorForUp,ColorForCenterUp,TrendLineWidth);
   }
   if(FanMode == 3)
   {
      if(ShowHighFan) drawFan(UniqueID+timeFrameToString(timeFrame)+":1:",
                           iOpen(NULL,timeFrame,BarForHighLow),               iTime(NULL,timeFrame,BarForHighLow),
                           iOpen(NULL,timeFrame,BarForHighLow)-EndPrice*Point,iTime(NULL,timeFrame,BarForHighLow)+EndTime*60*endTimetimeFrame,
                           ColorForDown,ColorForCenterDn,TrendLineWidth);
      if(ShowLowFan)  drawFan(UniqueID+timeFrameToString(timeFrame)+":2:",
                           iOpen(NULL,timeFrame,BarForHighLow),               iTime(NULL,timeFrame,BarForHighLow),
                           iOpen(NULL,timeFrame,BarForHighLow)+EndPrice*Point,iTime(NULL,timeFrame,BarForHighLow)+EndTime*60*endTimetimeFrame,
                           ColorForUp,ColorForCenterUp,TrendLineWidth);
   }
   return(0);
}

//------------------------------------------------------------------+
//                                                                  |
//------------------------------------------------------------------+

void drawFan(string name,double p1, datetime t1, double p2, datetime t2, color DrawColor = Gold, color DrawCenterColor = White, int Width = 1)
{
     if(ShowDegree0) SetTrend(name+"1", 0, t1, p1, t2, p2,                 DrawCenterColor, Width);
     if(ShowDegree1) SetTrend(name+"2", 0, t1, p1, t2, p1 + (p2 - p1)/2.0, DrawColor,       Width);
     if(ShowDegree2) SetTrend(name+"3", 0, t1, p1, t2, p1 + (p2 - p1)/3.0, DrawColor,       Width);
     if(ShowDegree3) SetTrend(name+"4", 0, t1, p1, t2, p1 + (p2 - p1)/4.0, DrawColor,       Width);
     if(ShowDegree4) SetTrend(name+"5", 0, t1, p1, t2, p1 + (p2 - p1)/8.0, DrawColor,       Width);
     if(ShowDegree1) SetTrend(name+"6", 0, t1, p1, t2, p1 + (p2 - p1)*2.0, DrawColor,       Width);
     if(ShowDegree2) SetTrend(name+"7", 0, t1, p1, t2, p1 + (p2 - p1)*3.0, DrawColor,       Width);
     if(ShowDegree3) SetTrend(name+"8", 0, t1, p1, t2, p1 + (p2 - p1)*4.0, DrawColor,       Width);
     if(ShowDegree4) SetTrend(name+"9", 0, t1, p1, t2, p1 + (p2 - p1)*8.0, DrawColor,       Width);
}

void SetTrend(string name, int window, datetime t1, double price1, datetime t2, double price2, color clr = Gold, int width = 1)
{
   ObjectCreate(name, OBJ_TREND, window, t1, price1, t2, price2);
   
   ObjectSet(name, OBJPROP_CORNER, 0);
   ObjectSet(name, OBJPROP_RAY,    1);
   ObjectSet(name, OBJPROP_COLOR,  clr);
   
   ObjectSet(name, OBJPROP_WIDTH,  width);
   ObjectSet(name, OBJPROP_TIME1,  t1);
   ObjectSet(name, OBJPROP_TIME2,  t2);
   ObjectSet(name, OBJPROP_PRICE1, price1);
   ObjectSet(name, OBJPROP_PRICE2, price2);
   ObjectSet(name, OBJPROP_STYLE,  TrendLineStyle);
}

//------------------------------------------------------------------+
//                                                                  |
//------------------------------------------------------------------+

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN1"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

string stringUpperCase(string str)
{
   string s=str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int Char = StringGetChar(s, length);
         if((Char > 96 && Char < 123) || (Char > 223 && Char < 256))
                     s = StringSetChar(s, length, Char - 32);
         else if(Char > -33 && Char < 0)
                     s = StringSetChar(s, length, Char + 224);
   }
   return(s);
}